Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
PrimitivesGeneratorPlugin Class Reference
Inheritance diagram for PrimitivesGeneratorPlugin:

## Public Slots
QString | version ()

## Signals
void | updateView ()
void | updatedObject (int _id, const UpdateType &_type)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | getMenubarMenu (QString _name, QMenu *&_menu, bool _create)
void | addEmptyObject (DataType _type, int &_id)
void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from MenuInterface
virtual void | getMenubarMenu (QString _name, QMenu *&_menu, bool _create)
| Get a existing top level menu pointer or create a new one. More...
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...
Signals inherited from RPCInterface
virtual void | pluginExists (QString _pluginName, bool &_exists)
Signals inherited from BackupInterface
virtual void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
int | addTriangulatedCylinder (const Vector &_position=Vector(0.0, 0.0, 0.0), const Vector &_axis=Vector(0.0, 0.0, 1.0), const double _radius=1.0, const double _height=5.0, const bool _top=true, const bool _bottom=true)
int | addSphere (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _radius=1.0)
int | addSubdivisionSphere (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _radius=1.0)
int | addTetrahedron (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addPyramid (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addCube (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addTriangulatedCube (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addIcosahedron (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addOctahedron (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)
int | addDodecahedron (const Vector &_position=Vector(0.0, 0.0, 0.0), const double _length=2.0)

## Private Slots
void | initializePlugin ()
| BaseInterface.
void | pluginsInitialized ()
void | noguiSupported ()
| Tell system that this plugin runs without ui.
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...

## Private Member Functions
int | addTriMesh ()
int | addPolyMesh ()
void | constructOctahedron (const Vector &_position, const double _length)
void | add_face (int _vh1, int _vh2, int _vh3)
void | add_face (int _vh1, int _vh2, int _vh3, int _vh4)
void | add_face (int _vh1, int _vh2, int _vh3, int _vh4, int _vh5)
ACG::Vec3d | positionOnCylinder (const int _sliceNumber, const int _stackNumber, const Vector _position, const Vector _axis, const double _radius, const double _height)
ACG::Vec3d | positionOnSphere (int _sliceNumber, int _stackNumber, const double _radius, const Vector &_position)
ACG::Vec2f | texCoordOnSphere (int _sliceNumber, int _stackNumber)
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from MenuInterface
virtual | ~MenuInterface ()
| Destructor.
virtual void | addMenubarAction (QAction *_action, QString _name)
| Adds an action to the menubar. More...
virtual void | addMenubarActions (std::vector< QAction *> &_actions, QString _name)
| Add multiple actions to the menu bar. More...
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...
Private Member Functions inherited from RPCInterface
virtual | ~RPCInterface ()
| Destructor.
virtual void | functionExists (QString _pluginName, QString _functionName, bool &_exists)
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from PythonInterface
virtual | ~PythonInterface ()
| Destructor.

## Private Attributes
std::vector< TriMesh::VertexHandle > | vhandles_
std::vector< PolyMesh::VertexHandle > | vphandles_
TriMesh * | triMesh_
PolyMesh * | polyMesh_
int | slices_
int | stacks_
QMenu * | primitivesMenu_

## Detailed Description

Definition at line 63 of file PrimitivesGenerator.hh.

## Member Function Documentation

## ◆ description()

QString PrimitivesGeneratorPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 102 of file PrimitivesGenerator.hh.

## ◆ name()

QString PrimitivesGeneratorPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 101 of file PrimitivesGenerator.hh.

The documentation for this class was generated from the following files:

- Plugin-PrimitivesGenerator/PrimitivesGenerator.hh
- Plugin-PrimitivesGenerator/PrimitivesGenerator.cc